/* Josh Pieper, (c) 2000 */

/*
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>

#ifndef WIN32
# include <sys/socket.h>
# include <netinet/in.h>
# include <arpa/inet.h>
# include <unistd.h>
#endif

#include "gnut.h" /* 0.4.28.c01 */
#include "monitor.h"
#include "queue.h"

Gnut_Queue * monitor_queue;

/* 0.4.28.c01 Moved mutex to gnut.c */

void fre_ms(monitored_search **x, int bugnum)
{
  yfre((void **) x, bugnum);
}

/* sets up our own monitor queue */
int monitor_init()
{
  monitor_queue = gnut_queue_new(513);
  return 0;
}

extern int deb1;

/* add a search request to the tail of the `monitor' list */
int monitor_search_add(char *search, int matched)
{
  monitored_search *ms;
  uchar * s;

  GD_S(3, "monitor_search_add entering\n");

  ms = (monitored_search *)ymaloc(sizeof(monitored_search), 305);
  ms->search = ystdup(search, 454);
  ms->matched = matched;

  for(s = ms->search; *s; s++) {
    if ((*s < 32) || (*s >= 127)) { /* tagok */
      *s = '#';
    }
  }

  pthread_mutex_lock(&monitor_mutex);
  gnut_queue_insert(monitor_queue, ms, 505);
  pthread_mutex_unlock(&monitor_mutex);

  GD_S(3, "monitor_search_add leaving\n");
  return 0;
}

monitored_search *monitor_search_get()
{
  monitored_search *ms;

  pthread_mutex_lock(&monitor_mutex);
  ms = gnut_queue_remove(monitor_queue);
  pthread_mutex_unlock(&monitor_mutex);
  
  return ms;
}
